
local _, TzTB = ...

--------------------------
-- TzTanaanBonus_OnLoad --
--------------------------
function TzTanaanBonus_OnLoad( _self )
	TzTB.frame = _self
end

--------------------------
-- WorldMapFrame_Update --
--------------------------
hooksecurefunc( "WorldMapFrame_Update", function()
	TzIcons_Hide()

----------------------------------------------------------------
-- Daily Bonus Objectives

	-- Tanaan Jungle
	if GetCurrentMapAreaID() == 945 then
		if TzTanaanBonusOptions.dailybonus_show then
			db = TzTB.db[ "BonusObjectives" ]

			for _, info in ipairs( db ) do
				local questCompleted = false

				for dbID = 4, #info, 1 do
					local questID = info[ dbID ]

					if IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					local icon = TzIcons_Get( "interface/minimap/objecticons", 47, TzTanaanBonusOptions.dailybonus_scale, 1.0 )
					local name = info[ 1 ]
					local x = ( info[ 2 ] / 100 ) * WorldMapDetailFrame:GetWidth()	-- Convert from TomTom
					local y = ( info[ 3 ] / 100 ) * WorldMapDetailFrame:GetHeight()	-- Convert from TomTom

					icon:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
					icon.text = format( "Bonus Objective: %s", name )
					icon:Show()
				end
			end
		end
	end

----------------------------------------------------------------
-- Mount Rares

	-- Tanaan Jungle
	if GetCurrentMapAreaID() == 945 then
		if TzTanaanBonusOptions.mountrares_show then
			db = TzTB.db[ "MountRares" ]

			for _, info in ipairs( db ) do
				local questCompleted = false

				for dbID = 4, #info, 1 do
					local questID = info[ dbID ]

					if IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					local icon = TzIcons_Get( "interface/minimap/objecticons", 41, TzTanaanBonusOptions.mountrares_scale, 1.0 )
					local name = info[ 1 ]
					local x = ( info[ 2 ] / 100 ) * WorldMapDetailFrame:GetWidth()	-- Convert from TomTom
					local y = ( info[ 3 ] / 100 ) * WorldMapDetailFrame:GetHeight()	-- Convert from TomTom

					icon:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
					icon.text = format( "Mount Rare: %s", name )
					icon:Show()
				end
			end
		end
	end

----------------------------------------------------------------
-- Toy Rares

	-- Tanaan Jungle
	if GetCurrentMapAreaID() == 945 then
		if TzTanaanBonusOptions.toyrares_show then
			db = TzTB.db[ "ToyRares" ]

			for _, info in ipairs( db ) do
				local questCompleted = false

				for dbID = 4, #info, 1 do
					local questID = info[ dbID ]

					if IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					local icon = TzIcons_Get( "interface/minimap/objecticons", 41, TzTanaanBonusOptions.toyrares_scale, 1.0 )
					local name = info[ 1 ]
					local x = ( info[ 2 ] / 100 ) * WorldMapDetailFrame:GetWidth()	-- Convert from TomTom
					local y = ( info[ 3 ] / 100 ) * WorldMapDetailFrame:GetHeight()	-- Convert from TomTom

					icon:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
					icon.text = format( "Toy Rare: %s", name )
					icon:Show()
				end
			end
		end
	end

----------------------------------------------------------------
-- Pet Rares

	-- Nagrand
	if GetCurrentMapAreaID() == 950 then
		if TzTanaanBonusOptions.petrares_show then
			db = TzTB.db[ "PetRares" ]

			for _, info in ipairs( db ) do
				local questCompleted = false

				for dbID = 4, #info, 1 do
					local questID = info[ dbID ]

					if IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					local icon = TzIcons_Get( "interface/minimap/objecticons", 41, TzTanaanBonusOptions.petrares_scale, 1.0 )
					local name = info[ 1 ]
					local x = ( info[ 2 ] / 100 ) * WorldMapDetailFrame:GetWidth()	-- Convert from TomTom
					local y = ( info[ 3 ] / 100 ) * WorldMapDetailFrame:GetHeight()	-- Convert from TomTom

					icon:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
					icon.text = format( "Pet Rare: %s", name )
					icon:Show()
				end
			end
		end
	end
end )
