
local _, TzTB = ...

-------------------------------
-- TzTanaanBonusPanel_OnLoad --
-------------------------------
function TzTanaanBonusPanel_OnLoad( _self )
	local parent

	TzTB.panel = _self
	TzTB.panel:RegisterEvent( "ADDON_LOADED" )

	TzTB.panel.name = "Tz: TanaanBonus"
	TzTB.panel.okay = function ( _self ) TzTanaanBonusPanel_OnOkay() end
	TzTB.panel.cancel = function ( _self ) TzTanaanBonusPanel_OnCancel() end
	InterfaceOptions_AddCategory( TzTB.panel )

	TzTB.panel.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_Head", "ARTWORK", "GameFontNormalLarge" )
	TzTB.panel.head:ClearAllPoints()
	TzTB.panel.head:SetPoint( "TOPLEFT", TzTB.panel, "TOPLEFT", 16, -16 )
	TzTB.panel.head:SetText( TzTB.panel.name )

	parent = TzTB.panel.head

----------------------------------------------------------------
-- Daily Bonus, head and background

	TzTB.panel.dailybonus = {}

	TzTB.panel.dailybonus.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_DailyBonus_Head", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.dailybonus.head:ClearAllPoints()
	TzTB.panel.dailybonus.head:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", 16, -8 )
	TzTB.panel.dailybonus.head:SetText( "Daily Bonus Objective Icons" )

	parent = TzTB.panel.dailybonus.head

	TzTB.panel.dailybonus.background	= CreateFrame( "Frame", TzTB.panel:GetName() .. "_DailyBonus_Background", TzTB.panel )
	TzTB.panel.dailybonus.background:SetSize( 308, 62 )
	TzTB.panel.dailybonus.background:SetBackdrop( {	bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
													edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
													tile = true,
													tileSize = 8,
													edgeSize = 14,
													insets = { left = 3, right = 3, top = 3, bottom = 3 } } )
	TzTB.panel.dailybonus.background:ClearAllPoints()
	TzTB.panel.dailybonus.background:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", -8, -2 )

	parent = TzTB.panel.dailybonus.background

----------------------------------------------------------------
-- Daily Bonus check button

	TzTB.panel.dailybonus.checkbutton	= CreateFrame( "CheckButton", TzTB.panel:GetName() .. "_DailyBonus_CheckButton", TzTB.panel.dailybonus.background, "OptionsCheckButtonTemplate" )
	TzTB.panel.dailybonus.checkbutton:ClearAllPoints()
	TzTB.panel.dailybonus.checkbutton:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 18, -18 )

	parent = TzTB.panel.dailybonus.checkbutton

	TzTB.panel.dailybonus.checkbutton.text = TzTB.panel.dailybonus.background:CreateFontString( TzTB.panel:GetName() .. "_DailyBonus_CheckButton_Text", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.dailybonus.checkbutton.text:ClearAllPoints()
	TzTB.panel.dailybonus.checkbutton.text:SetPoint( "LEFT", parent:GetName(), "RIGHT", 0, 1 )
	TzTB.panel.dailybonus.checkbutton.text:SetText( "Show" )

	parent = TzTB.panel.dailybonus.background

----------------------------------------------------------------
-- Daily Bonus slider

	TzTB.panel.dailybonus.slider	= CreateFrame( "Slider", TzTB.panel:GetName() .. "_DailyBonus_Slider", TzTB.panel, "OptionsSliderTemplate" )
	TzTB.panel.dailybonus.slider:ClearAllPoints()
	TzTB.panel.dailybonus.slider:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 128, -24 )
	TzTB.panel.dailybonus.slider:SetMinMaxValues( 1, 64 )
	TzTB.panel.dailybonus.slider:SetValueStep( 1 )

	getglobal( TzTB.panel.dailybonus.slider:GetName() .. "Low" ):SetText( "1" )
	getglobal( TzTB.panel.dailybonus.slider:GetName() .. "High" ):SetText( "64" )
	getglobal( TzTB.panel.dailybonus.slider:GetName() .. "Text" ):SetText( "Icon Scale" )

	parent = TzTB.panel.dailybonus.slider

	TzTB.panel.dailybonus.slider.value = TzTB.panel.dailybonus.background:CreateFontString( TzTB.panel:GetName() .. "_DailyBonus_Slider_Value", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.dailybonus.slider.value:ClearAllPoints()
	TzTB.panel.dailybonus.slider.value:SetPoint( "CENTER", parent:GetName(), "CENTER", 0, -12 )
	TzTB.panel.dailybonus.slider.value:SetText( "16" )

	TzTB.panel.dailybonus.slider:SetScript( "OnValueChanged",
	function( _self, _value )
-- ValueStep bug fix begin
		if not _self._onsetting then
			_self._onsetting = true
			_self:SetValue( _self:GetValue() )
			_value = _self:GetValue()
			_self._onsetting = false
		else
			return
		end
-- ValueStep bug fix end

		TzTB.panel.dailybonus.slider.value:SetText( _value )
	end )

	parent = TzTB.panel.dailybonus.background

----------------------------------------------------------------
-- Mount Rares, head and background

	TzTB.panel.mountrares = {}

	TzTB.panel.mountrares.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_MountRares_Head", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.mountrares.head:ClearAllPoints()
	TzTB.panel.mountrares.head:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", 8, -8 )
	TzTB.panel.mountrares.head:SetText( "Mount Rares Icons" )

	parent = TzTB.panel.mountrares.head

	TzTB.panel.mountrares.background	= CreateFrame( "Frame", TzTB.panel:GetName() .. "_MountRares_Background", TzTB.panel )
	TzTB.panel.mountrares.background:SetSize( 308, 62 )
	TzTB.panel.mountrares.background:SetBackdrop( {	bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
												tile = true,
												tileSize = 8,
												edgeSize = 14,
												insets = { left = 3, right = 3, top = 3, bottom = 3 } } )
	TzTB.panel.mountrares.background:ClearAllPoints()
	TzTB.panel.mountrares.background:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", -8, -2 )

	parent = TzTB.panel.mountrares.background

----------------------------------------------------------------
-- Mount Rares check button

	TzTB.panel.mountrares.checkbutton	= CreateFrame( "CheckButton", TzTB.panel:GetName() .. "_MountRares_CheckButton", TzTB.panel.mountrares.background, "OptionsCheckButtonTemplate" )
	TzTB.panel.mountrares.checkbutton:ClearAllPoints()
	TzTB.panel.mountrares.checkbutton:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 18, -18 )

	parent = TzTB.panel.mountrares.checkbutton

	TzTB.panel.mountrares.checkbutton.text = TzTB.panel.mountrares.background:CreateFontString( TzTB.panel:GetName() .. "_MountRares_CheckButton_Text", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.mountrares.checkbutton.text:ClearAllPoints()
	TzTB.panel.mountrares.checkbutton.text:SetPoint( "LEFT", parent:GetName(), "RIGHT", 0, 1 )
	TzTB.panel.mountrares.checkbutton.text:SetText( "Show" )

	parent = TzTB.panel.mountrares.background

----------------------------------------------------------------
-- Mount Rares slider

	TzTB.panel.mountrares.slider	= CreateFrame( "Slider", TzTB.panel:GetName() .. "_MountRares_Slider", TzTB.panel, "OptionsSliderTemplate" )
	TzTB.panel.mountrares.slider:ClearAllPoints()
	TzTB.panel.mountrares.slider:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 128, -24 )
	TzTB.panel.mountrares.slider:SetMinMaxValues( 1, 64 )
	TzTB.panel.mountrares.slider:SetValueStep( 1 )

	getglobal( TzTB.panel.mountrares.slider:GetName() .. "Low" ):SetText( "1" )
	getglobal( TzTB.panel.mountrares.slider:GetName() .. "High" ):SetText( "64" )
	getglobal( TzTB.panel.mountrares.slider:GetName() .. "Text" ):SetText( "Icon Scale" )

	parent = TzTB.panel.mountrares.slider

	TzTB.panel.mountrares.slider.value = TzTB.panel.mountrares.background:CreateFontString( TzTB.panel:GetName() .. "_MountRares_Slider_Value", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.mountrares.slider.value:ClearAllPoints()
	TzTB.panel.mountrares.slider.value:SetPoint( "CENTER", parent:GetName(), "CENTER", 0, -12 )
	TzTB.panel.mountrares.slider.value:SetText( "16" )

	TzTB.panel.mountrares.slider:SetScript( "OnValueChanged",
	function( _self, _value )
-- ValueStep bug fix begin
		if not _self._onsetting then
			_self._onsetting = true
			_self:SetValue( _self:GetValue() )
			_value = _self:GetValue()
			_self._onsetting = false
		else
			return
		end
-- ValueStep bug fix end

		TzTB.panel.mountrares.slider.value:SetText( _value )
	end )

	parent = TzTB.panel.mountrares.background

----------------------------------------------------------------
-- Toy Rares, head and background

	TzTB.panel.toyrares = {}

	TzTB.panel.toyrares.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_ToyRares_Head", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.toyrares.head:ClearAllPoints()
	TzTB.panel.toyrares.head:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", 8, -8 )
	TzTB.panel.toyrares.head:SetText( "Toy Rares Icons" )

	parent = TzTB.panel.toyrares.head

	TzTB.panel.toyrares.background	= CreateFrame( "Frame", TzTB.panel:GetName() .. "_ToyRares_Background", TzTB.panel )
	TzTB.panel.toyrares.background:SetSize( 308, 62 )
	TzTB.panel.toyrares.background:SetBackdrop( {	bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
												tile = true,
												tileSize = 8,
												edgeSize = 14,
												insets = { left = 3, right = 3, top = 3, bottom = 3 } } )
	TzTB.panel.toyrares.background:ClearAllPoints()
	TzTB.panel.toyrares.background:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", -8, -2 )

	parent = TzTB.panel.toyrares.background

----------------------------------------------------------------
-- Toy Rares check button

	TzTB.panel.toyrares.checkbutton	= CreateFrame( "CheckButton", TzTB.panel:GetName() .. "_ToyRares_CheckButton", TzTB.panel.toyrares.background, "OptionsCheckButtonTemplate" )
	TzTB.panel.toyrares.checkbutton:ClearAllPoints()
	TzTB.panel.toyrares.checkbutton:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 18, -18 )

	parent = TzTB.panel.toyrares.checkbutton

	TzTB.panel.toyrares.checkbutton.text = TzTB.panel.toyrares.background:CreateFontString( TzTB.panel:GetName() .. "_ToyRares_CheckButton_Text", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.toyrares.checkbutton.text:ClearAllPoints()
	TzTB.panel.toyrares.checkbutton.text:SetPoint( "LEFT", parent:GetName(), "RIGHT", 0, 1 )
	TzTB.panel.toyrares.checkbutton.text:SetText( "Show" )

	parent = TzTB.panel.toyrares.background

----------------------------------------------------------------
-- Toy Rares slider

	TzTB.panel.toyrares.slider	= CreateFrame( "Slider", TzTB.panel:GetName() .. "_ToyRares_Slider", TzTB.panel, "OptionsSliderTemplate" )
	TzTB.panel.toyrares.slider:ClearAllPoints()
	TzTB.panel.toyrares.slider:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 128, -24 )
	TzTB.panel.toyrares.slider:SetMinMaxValues( 1, 64 )
	TzTB.panel.toyrares.slider:SetValueStep( 1 )

	getglobal( TzTB.panel.toyrares.slider:GetName() .. "Low" ):SetText( "1" )
	getglobal( TzTB.panel.toyrares.slider:GetName() .. "High" ):SetText( "64" )
	getglobal( TzTB.panel.toyrares.slider:GetName() .. "Text" ):SetText( "Icon Scale" )

	parent = TzTB.panel.toyrares.slider

	TzTB.panel.toyrares.slider.value = TzTB.panel.toyrares.background:CreateFontString( TzTB.panel:GetName() .. "_ToyRares_Slider_Value", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.toyrares.slider.value:ClearAllPoints()
	TzTB.panel.toyrares.slider.value:SetPoint( "CENTER", parent:GetName(), "CENTER", 0, -12 )
	TzTB.panel.toyrares.slider.value:SetText( "16" )

	TzTB.panel.toyrares.slider:SetScript( "OnValueChanged",
	function( _self, _value )
-- ValueStep bug fix begin
		if not _self._onsetting then
			_self._onsetting = true
			_self:SetValue( _self:GetValue() )
			_value = _self:GetValue()
			_self._onsetting = false
		else
			return
		end
-- ValueStep bug fix end

		TzTB.panel.toyrares.slider.value:SetText( _value )
	end )

	parent = TzTB.panel.toyrares.background

----------------------------------------------------------------
-- Pet Rares, head and background

	TzTB.panel.petrares = {}

	TzTB.panel.petrares.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_PetRares_Head", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.petrares.head:ClearAllPoints()
	TzTB.panel.petrares.head:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", 8, -8 )
	TzTB.panel.petrares.head:SetText( "Pet Rares Icons" )

	parent = TzTB.panel.petrares.head

	TzTB.panel.petrares.background	= CreateFrame( "Frame", TzTB.panel:GetName() .. "_PetRares_Background", TzTB.panel )
	TzTB.panel.petrares.background:SetSize( 308, 62 )
	TzTB.panel.petrares.background:SetBackdrop( {	bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
												tile = true,
												tileSize = 8,
												edgeSize = 14,
												insets = { left = 3, right = 3, top = 3, bottom = 3 } } )
	TzTB.panel.petrares.background:ClearAllPoints()
	TzTB.panel.petrares.background:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", -8, -2 )

	parent = TzTB.panel.petrares.background

----------------------------------------------------------------
-- Pet Rares check button

	TzTB.panel.petrares.checkbutton	= CreateFrame( "CheckButton", TzTB.panel:GetName() .. "_PetRares_CheckButton", TzTB.panel.petrares.background, "OptionsCheckButtonTemplate" )
	TzTB.panel.petrares.checkbutton:ClearAllPoints()
	TzTB.panel.petrares.checkbutton:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 18, -18 )

	parent = TzTB.panel.petrares.checkbutton

	TzTB.panel.petrares.checkbutton.text = TzTB.panel.petrares.background:CreateFontString( TzTB.panel:GetName() .. "_PetRares_CheckButton_Text", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.petrares.checkbutton.text:ClearAllPoints()
	TzTB.panel.petrares.checkbutton.text:SetPoint( "LEFT", parent:GetName(), "RIGHT", 0, 1 )
	TzTB.panel.petrares.checkbutton.text:SetText( "Show" )

	parent = TzTB.panel.petrares.background

----------------------------------------------------------------
-- Pet Rares slider

	TzTB.panel.petrares.slider	= CreateFrame( "Slider", TzTB.panel:GetName() .. "_PetRares_Slider", TzTB.panel, "OptionsSliderTemplate" )
	TzTB.panel.petrares.slider:ClearAllPoints()
	TzTB.panel.petrares.slider:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 128, -24 )
	TzTB.panel.petrares.slider:SetMinMaxValues( 1, 64 )
	TzTB.panel.petrares.slider:SetValueStep( 1 )

	getglobal( TzTB.panel.petrares.slider:GetName() .. "Low" ):SetText( "1" )
	getglobal( TzTB.panel.petrares.slider:GetName() .. "High" ):SetText( "64" )
	getglobal( TzTB.panel.petrares.slider:GetName() .. "Text" ):SetText( "Icon Scale" )

	parent = TzTB.panel.petrares.slider

	TzTB.panel.petrares.slider.value = TzTB.panel.petrares.background:CreateFontString( TzTB.panel:GetName() .. "_PetRares_Slider_Value", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.petrares.slider.value:ClearAllPoints()
	TzTB.panel.petrares.slider.value:SetPoint( "CENTER", parent:GetName(), "CENTER", 0, -12 )
	TzTB.panel.petrares.slider.value:SetText( "16" )

	TzTB.panel.petrares.slider:SetScript( "OnValueChanged",
	function( _self, _value )
-- ValueStep bug fix begin
		if not _self._onsetting then
			_self._onsetting = true
			_self:SetValue( _self:GetValue() )
			_value = _self:GetValue()
			_self._onsetting = false
		else
			return
		end
-- ValueStep bug fix end

		TzTB.panel.petrares.slider.value:SetText( _value )
	end )

	parent = TzTB.panel.petrares.background
end

--------------------------------
-- TzTanaanBonusPanel_OnEvent --
--------------------------------
function TzTanaanBonusPanel_OnEvent( _self, _event, _name )
	if( _event == "ADDON_LOADED" and _name == "TzTanaanBonus" ) then

		if TzTanaanBonusOptions						== nil then	TzTanaanBonusOptions = {}						end
		if TzTanaanBonusOptions.dailybonus_show		== nil then	TzTanaanBonusOptions.dailybonus_show	= true	end
		if TzTanaanBonusOptions.dailybonus_scale	== nil then	TzTanaanBonusOptions.dailybonus_scale	= 32	end
		if TzTanaanBonusOptions.mountrares_show		== nil then	TzTanaanBonusOptions.mountrares_show	= true	end
		if TzTanaanBonusOptions.mountrares_scale	== nil then	TzTanaanBonusOptions.mountrares_scale	= 32	end
		if TzTanaanBonusOptions.petrares_show		== nil then	TzTanaanBonusOptions.petrares_show		= true	end
		if TzTanaanBonusOptions.petrares_scale		== nil then	TzTanaanBonusOptions.petrares_scale		= 32	end
		if TzTanaanBonusOptions.toyrares_show		== nil then	TzTanaanBonusOptions.toyrares_show		= true	end
		if TzTanaanBonusOptions.toyrares_scale		== nil then	TzTanaanBonusOptions.toyrares_scale		= 32	end

		TzTanaanBonusPanel_OnCancel()
	end
end

-------------------------------
-- TzTanaanBonusPanel_OnOkay --
-------------------------------
function TzTanaanBonusPanel_OnOkay( _self )
	TzTanaanBonusOptions.dailybonus_show	= TzTB.panel.dailybonus.checkbutton:GetChecked()
	TzTanaanBonusOptions.dailybonus_scale	= TzTB.panel.dailybonus.slider:GetValue()
	TzTanaanBonusOptions.mountrares_show	= TzTB.panel.mountrares.checkbutton:GetChecked()
	TzTanaanBonusOptions.mountrares_scale	= TzTB.panel.mountrares.slider:GetValue()
	TzTanaanBonusOptions.petrares_show		= TzTB.panel.petrares.checkbutton:GetChecked()
	TzTanaanBonusOptions.petrares_scale		= TzTB.panel.petrares.slider:GetValue()
	TzTanaanBonusOptions.toyrares_show		= TzTB.panel.toyrares.checkbutton:GetChecked()
	TzTanaanBonusOptions.toyrares_scale		= TzTB.panel.toyrares.slider:GetValue()
end

---------------------------------
-- TzTanaanBonusPanel_OnCancel --
---------------------------------
function TzTanaanBonusPanel_OnCancel( _self )
	TzTB.panel.dailybonus.checkbutton:SetChecked( TzTanaanBonusOptions.dailybonus_show )
	TzTB.panel.dailybonus.slider:SetValue( TzTanaanBonusOptions.dailybonus_scale )
	TzTB.panel.mountrares.checkbutton:SetChecked( TzTanaanBonusOptions.mountrares_show )
	TzTB.panel.mountrares.slider:SetValue( TzTanaanBonusOptions.mountrares_scale )
	TzTB.panel.petrares.checkbutton:SetChecked( TzTanaanBonusOptions.petrares_show )
	TzTB.panel.petrares.slider:SetValue( TzTanaanBonusOptions.petrares_scale )
	TzTB.panel.toyrares.checkbutton:SetChecked( TzTanaanBonusOptions.toyrares_show )
	TzTB.panel.toyrares.slider:SetValue( TzTanaanBonusOptions.toyrares_scale )
end
